/* ************************************************************************** */
/*                                             _____ _  __       ___   __     */
/*  Script.cpp                                |  ___(_)/ _| ___ ( _ ) / /_    */
/*  Project: C-Engine                         | |_  | | |_ / _ \/ _ \| '_ \   */
/*                                            |  _| | |  _|  __/ (_) | (_) |  */
/*  Author: Fife <wasabifife@gmail.com>       |_|   |_|_|  \___|\___/ \___/   */
/*                                                                            */
/* ************************************************************************** */

#include "..\C-Engine\include\Object\Script.hpp"

Script::Script()
{
    OConteneur = NULL;
    EConteneur = NULL;
}

void Script::Start()
{

}

void Script::Update()
{

}

void Script::UpdateEverySecond()
{

}

void Script::Teleport( int x , int y , int level )
{
    GetEngine()->MoveObject(GetObject(),level);
    GetEngine()->SetCurrentLevel(level);
    GetObject()->GetTransform()->SetXY(x,y);
}

void Script::AffectObject(Object * OV)
{
    OConteneur = OV;
}

void Script::AffectEngine(Engine * EV)
{
    EConteneur = EV;
}

Object * Script::GetObject()
{
    return OConteneur;
}

Engine * Script::GetEngine()
{
    if(OConteneur) return OConteneur->GetEngine();

    return EConteneur;
}

//Render

void Script::SetIt( int v )
{
    if( GetObject()->GetRender() )GetObject()->GetRender()->SetIt( v );
}

int Script::GetIt()
{
    if( GetObject()->GetRender() )return GetObject()->GetRender()->GetIt();

    return 0;
}

void Script::ReverseRender( bool v )
{
    if( GetObject()->GetRender() )GetObject()->GetRender()->ReverseRender( v );
}

bool Script::GetReverse()
{
    if( GetObject()->GetRender() )return GetObject()->GetRender()->GetReverse();

    return 0;
}

//Rigidbody

Body * Script::GetBody()
{
    if( GetObject()->GetRigidBody() )return GetObject()->GetRigidBody()->GetBody();

    return NULL;
}

void Script::Move( int  x , int  y )
{
    if( GetObject()->GetRigidBody() )GetObject()->GetRigidBody()->Move( x , y );
}


bool Script::CollisionDecor( int x , int y )
{
    if( GetObject()->GetRigidBody() )return GetObject()->GetRigidBody()->CollisionDecor( x , y );

    return 1;
}

//Transforms

int Script::GetX()
{
    if( GetObject()->GetTransform())return GetObject()->GetTransform()->GetX();

    return 0;
}

int Script::GetY()
{
    if( GetObject()->GetTransform())return GetObject()->GetTransform()->GetY();

    return 0;
}

void Script::SetX( int x )
{
   if( GetObject()->GetTransform()) GetObject()->GetTransform()->SetX( x );
}

void Script::SetY( int y)
{
    if( GetObject()->GetTransform()) GetObject()->GetTransform()->SetY( y );
}

void Script::SetXY( int x , int y )
{
    if( GetObject()->GetTransform()) GetObject()->GetTransform()->SetXY( x , y );
}




